/**
 * Copyright (c) 2014-2018 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see http://www.gnu.org/licenses/
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.extension.registry.overlay;

import java.lang.reflect.InvocationTargetException;
import java.util.Properties;

import org.easymock.EasyMock;
import org.junit.Test;
import org.ow2.petals.microkernel.api.configuration.ConfigurationService;

import com.ebmwebsourcing.easycommons.lang.reflect.ReflectionHelper;

/**
 * Unit test of {@link EmbeddedRegistryOverlayServiceImpl}
 * 
 * @author Christophe DENEUX - Linagora
 * 
 */
public class EmbeddedRegistryOverlayServiceImplTest {

    /**
     * <p>
     * Check that the extension correctly starts, and stops
     * </p>
     * <p>
     * Expected results: no error occurs during startup and stop
     * </p>
     * 
     */
    @Test
    public void testStart() throws InvocationTargetException {

        final ConfigurationService cfgSvcMock = EasyMock.createMock(ConfigurationService.class);
        EasyMock.expect(cfgSvcMock.getServerProperties()).andReturn(new Properties());
        EasyMock.replay(cfgSvcMock);

        final EmbeddedRegistryOverlayServiceImpl erosi = new EmbeddedRegistryOverlayServiceImpl();
        ReflectionHelper.setPrivateField(erosi, "configurationService", cfgSvcMock);

        ReflectionHelper.invokePrivateMethod(erosi, "start", null, null);
        ReflectionHelper.invokePrivateMethod(erosi, "stop", null, null);
    }

}
